Gui, Margin, 3, 5
Gui, +Resize


Gui, Add, Text     , xm     ym     w20  h20  Right 0x200                       , Dir:
Gui, Add, Edit     , xm+25  ym     w225 h20                 vDir_edt           , 
Gui, Add, Button   , xm+255 ym     w25  h20                 vDir_btn    gBrowse, ...
Gui, Add, Listview , xm     ym+25  w280 h200 AltSubmit Grid vList_lv           , Path
Gui, Add, Text     , xm     ym+230 w40  h20  Right 0x200    vSearch_txt        , Search: 
Gui, Add, Edit     , xm+45  ym+230 w180 h20                 vSearch_edt        , 
Gui, Add, Button   , xm+230 ym+230 w50  h20                 vSearch_btn gSearch, Search
Gui, Add, StatusBar,
SB_SetText( "Ready.", 1 )
Gui, Show, , SubDirSearcher
Return


GuiEscape:
GuiClose:
{
    ExitApp
}
Return


GuiSize:
{
    Anchor( "Dir_edt"   , "w" , 1 )
    Anchor( "Dir_btn"   , "x" , 1 )
    Anchor( "List_lv"   , "wh", 1 )
    Anchor( "Search_txt", "y" , 1 )
    Anchor( "Search_edt", "wy", 1 )
    Anchor( "Search_btn", "xy", 1 )
}
Return


Browse:
{
    Gui, 1: Submit, NoHide
    If ( A_GuiControl = "Dir_btn" )
    {
        Source_Folder := ""
        FileSelectFolder, Source_Folder, , 2, Select source folder.
        If ( ErrorLevel != 1 )
        {
            GuiControl, Text, Dir_edt, % Source_Folder
        }
    }
    ; Right-justify edit field.
    SendMessage, 0xB1, 500, 500, Edit1
}
Return


Search:
{
    Gui, Submit, NoHide
    
    ; Error checking before processing.
    If ( !FileExist( Dir_edt ) )
    {
        MsgBox, 48, Error, Please select a valid source folder.
        Return
    }
    If ( Search_edt = "" )
    {
        MsgBox, 48, Error, Please provide a search term.
        Return
    }
    
    ; Process.
    Loop, % Dir_edt . "\*.*", 1, 1
    {
        SB_SetText( "Scanning: " . A_LoopFileDir, 1 )
        If !FileExist( A_LoopFileDir . "\" . Search_edt )
        {
            If ( A_LoopFileDir != Prev_Dir )
            {
                LV_Add( "", A_LoopFileDir )
                LV_ModifyCol( 1, "AutoHdr" )
            }
            Prev_Dir := A_LoopFileDir
        }
    }
    SB_SetText( "Done.", 1 )
}
Return


Anchor(c, a = "", r = false) { ; v3.6 - Titan
    static d
	GuiControlGet, p, Pos, %c%
	If ex := ErrorLevel {
		Gui, %A_Gui%:+LastFound
		ControlGetPos, px, py, pw, ph, %c%
	}
	If !(A_Gui or px) and a
		Return
	i = x.w.y.h./.7.%A_GuiWidth%.%A_GuiHeight%.`n%A_Gui%:%c%=
	StringSplit, i, i, .
	d := a ? d . ((n := !InStr(d, i9)) ? i9 : "")
		: RegExReplace(d, "\n\d+:" . c . "=[\-\.\d\/]+")
	Loop, 4
		x := A_Index, j := i%x%, i6 += x = 3
		, k := !RegExMatch(a, j . "([\d.]+)", v) + (v1 ? v1 : 0)
		, e := p%j% - i%i6% * k, d .= n ? e . i5 : ""
		, RegExMatch(d, "\Q" . i9 . "\E(?:([\d.\-]+)/){" . x . "}", v)
		, l .= p%j% := InStr(a, j) ? (ex ? "" : j) . v1 + i%i6% * k : ""
	If r
		rx = Draw
	If ex
		ControlMove, %c%, px, py, pw, ph
	Else GuiControl, Move%rx%, %c%, %l%
}
